Тёмный

Freedom Trail - Leetcode 514 - Python 

NeetCodeIO
Подписаться 149 тыс.
Просмотров 14 тыс.
50% 1

Опубликовано:

 

20 июл 2024

Поделиться:

Ссылка:

Скачать:

Готовим ссылку...

Добавить в:

Мой плейлист
Посмотреть позже
Комментарии : 50   
@siddharth-gandhi
@siddharth-gandhi 2 месяца назад
bro single handedly saving my streak. thanks for doing this :)
@yang5843
@yang5843 2 месяца назад
These problem descriptions are getting out of hand
@vjnt1star
@vjnt1star 2 месяца назад
I agree, a couple of months ago I was looking for a job and I was given some leetcode problems to solve. The description was very long and I had to read it a couple of times because it was going all over the place. After a while focusing on the example the things to do was not so complicated. But my god so much time wasted on blabla when the timer is running down at the same time
@anand_dudi
@anand_dudi 2 месяца назад
Only channel on whole youtube which is best not just solving leetcode problems but also to explaining the problem as much as simple possible with many approaches DAMM
@chaitanya812
@chaitanya812 2 месяца назад
another problem with dp vs greedy ... where greedy fails
@huyennguyenmaingoc468
@huyennguyenmaingoc468 2 месяца назад
Thank you Neetcode, I learned Algorithm from your series by watching the whole Medium playlist. Now I passed my Codility test and got the first internship, which I thought I couldn't 2 months ago XD
@mnaresh3382
@mnaresh3382 2 месяца назад
I am happy that atleast I was able to try the problem in the SMART way, and ofcourse failed 😂😂
@williamdufault6413
@williamdufault6413 2 месяца назад
python 80ms - recursion + memoization + binary search class Solution: def findRotateSteps(self, ring: str, key: str) -> int: @cache def dfs(r: int, k: int) -> int: if k == len(key): return 0 steps = math.inf for i in get_closest_indexes(r, key[k]): steps = min(steps, get_min_distance(r, i) + dfs(i, k + 1)) return 1 + steps def get_closest_indexes(i: int, char: str) -> Tuple[int]: if ring[i] == char: return (i,) char_indexes = indexes[char] if len(char_indexes) == 1: return tuple(char_indexes) l, r = 0, len(char_indexes) - 1 while l < r: m = l + (r - l) // 2 if char_indexes[m] < i: l = m + 1 else: r = m - 1 return ( char_indexes[l], char_indexes[l - 1] if char_indexes[l] > i \ else char_indexes[(l + 1) % len(char_indexes)] ) def get_min_distance(i: int, j: int) -> int: diff = abs(i - j) return min(diff, len(ring) - diff) indexes = defaultdict(list) for i, char in enumerate(ring): indexes[char].append(i) return dfs(0, 0)
@MP-ny3ep
@MP-ny3ep 2 месяца назад
Phenomenal explanation as always. Thank you
@Munchen888
@Munchen888 2 месяца назад
Neetcode, thank you for detailed explanation specially when using recursion. A decision tree really helps to divide and conquer the problem. By the way dp solution are better. Thanks 😊
@yassinesafraoui
@yassinesafraoui 2 месяца назад
Am I supposed to have a solution that works from the first try "normally"? because I always write a solution that works for basic cases and then I start finding bugs I didn't see after submitting the thing, I think that's because I don't completely see what my code is doing until I get a hint by the failed submissions that probably this part isn't working, how do you guys deal with this? is it just me or it's about me not trying to go over the code again and again to try and catch bugs before submitting the solution, if that's the case, is it really what should happens when coding in real life situations?
@user-jn7mo1ri3m
@user-jn7mo1ri3m 2 месяца назад
For the recursive solution with memoization, although it makes the code a little messier, you don't really need to consider all possible occurrences of a particular key character in the ring. Finding the first occurrence of the required character towards the left and the right and then recursively solving the rest of the problem is also adequate! But yeah great solution that helped me save my streak! Keep writing more neet code! :D
@swamysriman7147
@swamysriman7147 2 месяца назад
No, that would be greedy and we'd miss better, but further positions
@yassinesafraoui
@yassinesafraoui 2 месяца назад
I just saw now that this is the same problem we'll have to solve if we tried to type a string using a wheel that contains letters if we have the same mechanism as the those old phone wheels, the only difference is that phone wheels has has only numbers and they appear only once, this is a more general situation
@IK-xk7ex
@IK-xk7ex 2 месяца назад
I recognise that it is DP problem, but I get stuck at the moment how to find circular offset, blain on me. After the moment you get the explanation I solved it by myself.
@satyamjha68
@satyamjha68 2 месяца назад
Solved it!!
@thefreemarketdev
@thefreemarketdev 2 месяца назад
The DP drawing is very helpful
@STLofi764
@STLofi764 2 месяца назад
21-1
@get_out_it
@get_out_it 2 месяца назад
I’m adept at problem solving complex technical issues)
@hida-steak-donburi
@hida-steak-donburi 2 месяца назад
Whoelse came up with Greedy solution and got suboptimal like me...
@tawfikkoptan5781
@tawfikkoptan5781 2 месяца назад
PLEASE SOLVE TODAY'S CONTEST'S PROBLEM "Find All Possible Stable Binary Arrays I" BECAUSE IT WAS SO SO DIFFICULT 😭😭😭😭
@aswathchandrasekar2917
@aswathchandrasekar2917 2 месяца назад
Really good!!!!
@sheersendughosh
@sheersendughosh 2 месяца назад
Thanks for the solution! If we come up with the caching solution and not the best optimal approach is it considered bad in an real interview? Can you kindly show/share code snippet for both caching solution and the optimal sol that you would do in a real FAANG interview? Love your videos❤
@tanzeembelal3177
@tanzeembelal3177 2 месяца назад
Please solve contest problems for leetcode it will be so beneficial your quality of explanation is what we want please please please
@raghavrathi2412
@raghavrathi2412 2 месяца назад
Please do yesterday's daily question i.e sum of distances in a tree, it seems like a really good question
@johnrivers9931
@johnrivers9931 2 месяца назад
this was a pretty cool problem
@ashrafuldowla6214
@ashrafuldowla6214 2 месяца назад
recursive 2state dp with memoization
@shahnawazhussain4925
@shahnawazhussain4925 2 месяца назад
Hii. I have a request. Please make a video on the problem "1915: Number of wonderful substrings". No matter how hard i try i could not understand the logic. I watch your videos and i think you can explain it to me. And i am pretty sure i will understand if you make a video on this problem. Please take it as a request. Thanks. love your videos
@soumyajitchatterjee5822
@soumyajitchatterjee5822 2 месяца назад
I need to practice more......
@betabias
@betabias 2 месяца назад
"wanna spend your life doing that" xD, tabulation gives me nightmares
@Kauliflower-yl8te
@Kauliflower-yl8te 2 месяца назад
To understand recursion you must first understand recursion
@transient6366
@transient6366 2 месяца назад
in desperate need for a good solution of 1915. Number of Wonderful Substrings cant find anywhere
@diasutsman
@diasutsman 2 месяца назад
Bro the video embed in your courses are not working
@wytsai7660
@wytsai7660 2 месяца назад
4:55 Sorry, but I still can’t see why trying every characters (those three 'b's) won’t make our solution more inefficient 😢 Can somebody explain to me 🙏
@nikhil199029
@nikhil199029 2 месяца назад
21:45 Martin Fowler wants to know your location.
@Mayanksingh-qp6dy
@Mayanksingh-qp6dy 2 месяца назад
I have a question would be thankful if someone can please explain. In recursive solution if c == key[k] min_dist = min(abs(r-i), len - abs(r-i)) why are we taking this minimum instead of trying out both the solutions, as taking the minimum won't make this approach greedy?
@LOKESHE-wi2yd
@LOKESHE-wi2yd 2 месяца назад
same doubt here , if the distance may decrease upon upcoming key values as he mentioned in 2:57 , why using greedy , i haven't watched full video yet , did he changed it in tabulation part
@LOKESHE-wi2yd
@LOKESHE-wi2yd 2 месяца назад
gotcha , he selecting the minimum upon each recursive calls at line15 at timestamp 13:39
@benmaduabuchi1636
@benmaduabuchi1636 2 месяца назад
solved it w a heap and it worked 💀
@deadlyecho
@deadlyecho 2 месяца назад
Vault-tec 😂😂😂
@pushkarsaini2
@pushkarsaini2 2 месяца назад
where are you man?? 2 days no solutions
@deadlyecho
@deadlyecho 2 месяца назад
Wouldn't it be easier if we concatenated the string with itself to make the recurssive solution easier ?
@ashrafuldowla6214
@ashrafuldowla6214 2 месяца назад
you don't need to concatenate the string. try to find the distance between two indices both clockwise and anti-clockwise.
@deadlyecho
@deadlyecho 2 месяца назад
@@ashrafuldowla6214 Yeah maybe, I just thought we could make it easier by doing this concat, didn't try it though
@yuvrajmalhotra9276
@yuvrajmalhotra9276 2 месяца назад
what do u mean by easier ? r u trying to get rid of that formula to find distance if we move anticlockwise ? if this is tru then why stake all that space and you also have to write extra code.. just use a simple formula i.e key.size-absolute(nextPos-currentClockHand)
@ashrafuldowla6214
@ashrafuldowla6214 2 месяца назад
@@yuvrajmalhotra9276 i did the same thing using the formula. I just only explained elaborately
@deadlyecho
@deadlyecho 2 месяца назад
@@yuvrajmalhotra9276 Yes, well twice the length of the string is not so bad 2*N after all... didn't try how it will work out though just an idea
@pastori2672
@pastori2672 2 месяца назад
btw in python you can just do res = inf or -inf its a shorter then float("inf")
@HuyLe-tu4pj
@HuyLe-tu4pj 2 месяца назад
The brute force is not easy at all 🥲
Далее
Minimum Cost to Hire K Workers - Leetcode 857 - Python
19:01
Permutations - Leetcode 46 - Python
11:58
Просмотров 8 тыс.
АРЕХ ПОЙМАЛ БЕЛКУ ОТ ИГРЫ ВП
15:01
World Record Tunnel Glide 🪂
00:19
Просмотров 17 млн
Time Needed to Buy Tickets - Leetcode 2073 - Python
12:45
Coding Interviews Be Like
5:31
Просмотров 6 млн
10 Math Concepts for Programmers
9:32
Просмотров 1,8 млн
5 Useful F-String Tricks In Python
10:02
Просмотров 279 тыс.
8 patterns to solve 80% Leetcode problems
7:30
Просмотров 255 тыс.
How I would learn Leetcode if I could start over
18:03
Просмотров 348 тыс.
АРЕХ ПОЙМАЛ БЕЛКУ ОТ ИГРЫ ВП
15:01